local L = LibStub("AceLocale-3.0"):GetLocale("Utopia")

Utopia.data = {
	[L["Armor (Major)"]] = {
		icon = select(3, GetSpellInfo(47467)),
		spells = {
			[GetSpellInfo(48669)] = {						-- Expose Armor
				class = "ROGUE",
				rankLevels = {14, 26, 36, 46, 56, 66, 77},
				amountsPerStack = {90, 180, 270, 360, 450, 520, 785},
				--amountPerStack = 785,
				maxStacks = 5
			},
			[GetSpellInfo(47467)] = {						-- Sunder Armor
				class = "WARRIOR",
				rankLevels = {10, 22, 34, 46, 58, 67, 77},
				amountsPerStack = {90, 180, 270, 360, 450, 520, 785},
				--amountPerStack = 785,
				maxStacks = 5
			},
			[GetSpellInfo(55754)] = {						-- Acid Spit
				class = "HUNTER",
				rankLevels = {1, 16, 32, 48, 64, 80},
				amountsPerStack = {10, 120, 250, 360, 520, 785},
				--amountPerStack = 785,
				maxStacks = 5,
				spec = "BEASTMASTER",
				requiredTalent = GetSpellInfo(53270),		-- Beast Mastery
				info = L["Sporebat"]
			},
		},
	},
	[L["Armor (Minor)"]] = {
		icon = select(3, GetSpellInfo(48476)),
		spells = {
			[GetSpellInfo(57595)] = {						-- Curse of Recklessness
				class = "WARLOCK",
				rankLevels = {14, 28, 42, 56, 69, 79},
				amounts = {175, 285, 395, 505, 610, 1260},
				--amount = 1260
			},
			[GetSpellInfo(48476)] = {						-- Faerie Fire
				class = "DRUID",
				rankLevels = {18, 30, 42, 54, 66, 76},
				amounts = {175, 285, 395, 505, 610, 1260},
				--amount = 1260
			},
			[GetSpellInfo(48475)] = {						-- Faerie Fire (Feral)
				class = "DRUID",
				rankLevels = {18, 30, 42, 54, 66, 76},
				amounts = {175, 285, 395, 505, 610, 1260},
				--amount = 1260
			},
			[GetSpellInfo(56631)] = {						-- Sting
				class = "HUNTER",
				rankLevels = {1, 16, 32, 48, 64, 80},
				amounts = {175, 285, 395, 505, 610, 1260},
				--amount = 1260,
				info = L["Wasp"]
			},
		},
	},
	[L["Attack Power"]] = {
		icon = select(3, GetSpellInfo(47437)),
		spells = {
			[GetSpellInfo(50511)] = {						-- Curse of Weakness
				class = "WARLOCK",
				rankLevels = {4, 12, 22, 32, 42, 52, 61, 69, 71},
				amounts = {21, 41, 64, 82, 123, 163, 257, 350, 478},
				--amount = 478,
				spec = "AFFLICTION",
				improvedPercentagePerTalentPoint = 10,
				maxTalentPoints = 2,
				improved = GetSpellInfo(18179)				-- Frailty
			},
			[GetSpellInfo(48560)] = {						-- Demoralizing Roar
				class = "DRUID",
				rankLevels = {10, 20, 32, 42, 52, 62, 71, 77},
				amounts = {31, 51, 68, 103, 138, 220, 299, 408},
				--amount = 408,
				spec = "FERAL",
				improvedPercentagePerTalentPoint = 8,
				maxTalentPoints = 5,
				improved = GetSpellInfo(16862)				-- Feral Aggression
			},
			[GetSpellInfo(47437)] = {						-- Demoralizing Shout
				class = "WARRIOR",
				rankLevels = {14, 24, 34, 44, 54, 62, 70, 79},
				amounts = {35, 55, 70, 105, 140, 220, 300, 418},
				--amount = 410,
				spec = "FURY",
				improvedPercentagePerTalentPoint = 8,
				maxTalentPoints = 5,
				improved = GetSpellInfo(12879)				-- Improved Demoralizing Shout
			},
			[GetSpellInfo(55487)] = {						-- Demoralizing Screech
				class = "HUNTER",
				rankLevels = {1, 16, 32, 48, 64, 80},
				amounts = {25, 45, 70, 100, 210, 410},
				--amount = 410,
				info = L["Bird"],
				improved = GetSpellInfo(12879)
			},
		},
	},
	[L["Bleed Damage"]] = {
		icon = select(3, GetSpellInfo(48564)),
		spells = {
			[GetSpellInfo(48564)] = {						-- Mangle - Bear
				class = "DRUID",
				amount = 30,
				amountType = "%",
				spec = "FERAL"
			},
			[GetSpellInfo(48566)] = {						-- Mangle - Cat
				class = "DRUID",
				amount = 30,
				amountType = "%",
				spec = "FERAL"
			},
			[GetSpellInfo(46855)] = {						-- Trauma
				class = "WARRIOR",
				amount = 30,
				amountType = "%"
			},
		},
	},
	[L["Cast Speed Slow"]] = {
		icon = select(3, GetSpellInfo(5761)),
		spells = {
			[GetSpellInfo(11719)] = {						-- Curse of Tongues
				class = "WARLOCK",
				amount = 60,
				amountType = "%"
			},
			[GetSpellInfo(5761)] = {						-- Mind-numbing Poison
				class = "ROGUE",
				amount = 60,
				amountType = "%"
			},
			[GetSpellInfo(58611)] = {						-- Lava Breath
				class = "HUNTER",
				amount = 50,
				amountType = "%",
				spec = "BEASTMASTER",
				requiredTalent = GetSpellInfo(53270),		-- Beast Mastery
				info = L["Core Hound"]
			},
			[GetSpellInfo(31589)] = {						-- Slow
				class = "MAGE",
				spec = "ARCANE",
				requiredTalent = GetSpellInfo(31589),		-- Slow
				amount = 60,
				amountType = "%"
			},
		},
	},
	[L["Critical Strike Chance Taken"]] = {
		icon = select(3, GetSpellInfo(58410)),
		spells = {
			[GetSpellInfo(20337)] = {						-- Heart of the Crusader
				class = "PALADIN",
				spec = "RETRIBUTION",
				maxTalentPoints = 3,
				amountPerTalentPoint = 1,
				amountType = "%",
				requiredTalent = GetSpellInfo(20337)		-- Heart of the Crusader
			},
			[GetSpellInfo(58410)] = {						-- Master Poisoner
				class = "ROGUE",
				spec = "ASSASSINATION",
				maxTalentPoints = 3,
				amountPerTalentPoint = 1,
				amountType = "%",
				requiredTalent = GetSpellInfo(58410)		-- Master Poisoner
			},
			[GetSpellInfo(30706)] = {						-- Totem of Wrath
				class = "SHAMAN",
				spec = "ELEMENTAL",
				amount = 3,
				amountType = "%",
				requiredTalent = GetSpellInfo(30706)		-- Totem of Wrath
			},
		},
	},
	[L["Healing Taken"]] = {
		icon = select(3, GetSpellInfo(47486)),
		spells = {
			[GetSpellInfo(49050)] = {						-- Aimed Shot
				class = "HUNTER",
				spec = "MARKSMANSHIP",
				amount = 50,
				amountType = "%",
				requiredTalent = GetSpellInfo(49050)		-- Aimed Shot
			},
			[GetSpellInfo(46911)] = {						-- Furious Attacks
				class = "WARRIOR",
				spec = "FURY",
				amountPerStack = 25,
				maxStacks = 2,
				amountType = "%",
				requiredTalent = GetSpellInfo(46911)		-- Furious Attacks
			},
			[GetSpellInfo(47486)] = {						-- Mortal Strike
				class = "WARRIOR",
				spec = "ARMS",
				amount = 50,
				amountType = "%",
				requiredTalent = GetSpellInfo(47486)		-- Mortal Strike
			},
			[GetSpellInfo(13218)] = {						-- Wound Poison (all ranks)
				class = "ROGUE",
				amount = 50,
				amountType = "%"
			},
		},
	},
	[L["Health Restore"]] = {
		icon = select(3, GetSpellInfo(20271)),
		spells = {
			[GetSpellInfo(20271)] = {						-- Judgement of Light
				class = "PALADIN",
				exclusiveWith = L["Mana Restore"]
			},
		},
	},
	[L["Mana Restore"]] = {
		icon = select(3, GetSpellInfo(53408)),
		spells = {
			[GetSpellInfo(53408)] = {						-- Judgement of Wisdom
				class = "PALADIN",
				exclusiveWith = L["Health Restore"]
			},
		},		
	},
	[L["Melee Attack Speed Slow"]] = {
		icon = select(3, GetSpellInfo(47502)),
		spells = {
			[GetSpellInfo(49909)] = {						-- Icy Touch
				class = "DEATHKNIGHT",
				spec = "FROST",
				amount = 14,
				amountType = "%",
				improvedAmountPerTalentPoint = 2,
				maxTalentPoints = 3,
				improved = GetSpellInfo(51456)				-- Improved Icy Touch
			},
			[GetSpellInfo(48485)] = {						-- Infected Wounds
				class = "DRUID",
				spec = "FERAL",
				maxStacks = 2,
				amountPerTalentPoint = 10/3,
				amountType = "%",
				maxTalentPoints = 3,
				requiredTalent = GetSpellInfo(48485)		-- Infected Wounds
			},
			[GetSpellInfo(53696)] = {						-- Judgements of the Just
				class = "PALADIN",
				spec = "PROTECTION",
				amount = 20,
				amountType = "%",
				requiredTalent = GetSpellInfo(53696)		-- Judgements of the Just
			},
			[GetSpellInfo(47502)] = {						-- Thunder Clap
				class = "WARRIOR",
				spec = "PROTECTION",
				amount = 10,
				amountType = "%",
				maxTalentPoints = 3,
				improvedAmountPerTalentPoint = 10/3,
				improved = GetSpellInfo(12666)				-- Improved Thunder Clap
			},
		},
	},
	[L["Melee Hit Chance Reduction"]] = {
		icon = select(3, GetSpellInfo(48468)),
		spells = {
			[GetSpellInfo(48468)] = {						-- Insect Swarm
				class = "DRUID",
				amount = 3,
				amountType = "%"
			},
			[GetSpellInfo(3043)] = {						-- Scorpid Sting
				class = "HUNTER",
				amount = 3,
				amountType = "%"
			},
		},
	},
	[L["Physical Vulnerability"]] = {
		icon = select(3, GetSpellInfo(58413)),
		spells = {
			[GetSpellInfo(29859)] = {						-- Blood Frenzy
				class = "WARRIOR",
				spec = "ARMS",
				amountPerTalentPoint = 1,
				amountType = "%",
				maxTalentPoints = 2,
				requiredTalent = GetSpellInfo(29859)		-- Blood Frenzy
			},
			[GetSpellInfo(58413)] = {						-- Savage Combat
				class = "ROGUE",
				spec = "COMBAT",
				amountPerTalentPoint = 1,
				amountType = "%",
				maxTalentPoints = 2,
				requiredTalent = GetSpellInfo(58413)		-- Savage Combat
			},
		},
	},
	[L["Spell Critical Strike Chance"]] = {
		icon = select(3, GetSpellInfo(12873)),
		spells = {
			[GetSpellInfo(12873)] = {						-- Improved Scorch
				class = "MAGE",
				spec = "FIRE",
				amountPerStack = 2,
				maxStacks = 5,
				amountType = "%",
				maxTalentPoints = 5,
				requiredTalent = GetSpellInfo(12873)
			},
			[GetSpellInfo(28593)] = {						-- Winter's Chill
				class = "MAGE",
				spec = "FROST",
				amountPerStack = 2,
				maxStacks = 5,
				amountType = "%",
				maxTalentPoints = 5,
				requiredTalent = GetSpellInfo(28593)
			},
		},
	},
	[L["Spell Damage Taken"]] = {
		icon = select(3, GetSpellInfo(47865)),
		spells = {
			[GetSpellInfo(47865)] = {						-- Curse of the Elements
				class = "WARLOCK",
				spec = "AFFLICTION",
				amount = 10,
				amountType = "%",
				maxTalentPoints = 3,
				improvedAmountPerTalentPoint = 1,
				improved = GetSpellInfo(32484)				-- Malediction
			},
			[GetSpellInfo(48513)] = {						-- Earth and Moon
				class = "DRUID",
				spec = "BALANCE",
				amountPerTalentPoint = 13/5,
				amountType = "%",
				maxTalentPoints = 5,
				requiredTalent = GetSpellInfo(48513)		-- Earth and Moon
			},
			[GetSpellInfo(51161)] = {						-- Ebon Plaguebringer
				class = "DEATHKNIGHT",
				spec = "UNHOLY",
				amountPerTalentPoint = 13/3,
				amountType = "%",
				maxTalentPoints = 3,
				requiredTalent = GetSpellInfo(51161)		-- Ebon Plaguebringer
			},
		},
	},
	[L["Spell Hit Chance Taken"]] = {
		icon = select(3, GetSpellInfo(33193)),
		spells = {
			[GetSpellInfo(33602)] = {						-- Improved Faerie Fire
				class = "DRUID",
				spec = "BALANCE",
				amountPerTalentPoint = 1,
				amountType = "%",
				maxTalentPoints = 3,
				requiredTalent = GetSpellInfo(33602)		-- Improved Faerie Fire
			},
			[GetSpellInfo(33193)] = {						-- Misery
				class = "PRIEST",
				spec = "SHADOW",
				amount = 3,
				amountType = "%",
				requiredTalent = GetSpellInfo(33193)		-- Misery
			},
		},
	},
}

for Type,data in pairs(Utopia.data) do
	assert(data.spells)
	for spellName,info in pairs(data.spells) do
		if (info.amountsPerStack) then
			assert(info.rankLevels)
			assert(#info.amountsPerStack == #info.rankLevels)
		elseif (info.amounts) then
			assert(info.rankLevels)
			assert(#info.amounts == #info.rankLevels)
		end
	end
end

	